{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE FlexibleContexts #-} {-# LANGUAGE TypeFamilies #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE DisambiguateRecordFields #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE TypeApplications #-}

{-# LANGUAGE NoImplicitPrelude #-}

module Client.Handlers
    ( module Client.Handlers.Profile
    , module Client.Handlers.Apply
    , module Client.Handlers.Applications
    , module Client.Handlers.VerifyEmail
    , getHomeR
    , postApiR
    ) where

import Relude

import Client.Handlers.Profile
import Client.Handlers.Apply
import Client.Handlers.Applications
import Client.Handlers.VerifyEmail
import Client.Types
import Yesod
import Yesod.Auth
import Server (serverApp)

getHomeR :: Handler Html
getHomeR = ifM (isJust <$> maybeAuthId) (redirect OwnProfileR) (redirect $ AuthR LoginR)

postApiR :: Handler ()
postApiR = sendWaiApplication =<< liftIO serverApp
