{-# LANGUAGE OverloadedStrings #-}

module Server.Email where

import Server.Types
import Data.Text (Text)
import Data.Text.Lazy (fromStrict)
import Network.Mail.Mime

sendVerificationEmail :: MonadEmail m => Email -> Text -> m ()
sendVerificationEmail to secret = do
    from <- fromAddress
    sendEmail $ simpleMail' (Address Nothing $ renderEmail to) from
        "Sähköpostin vahvistuskoodi" $ fromStrict $
        "Vahvista sähköpostisi syöttämällä alla oleva koodi rekisteriin:\n\n"
        <> secret <> "\n\n"
        <> "Mikäli et odottanut tätä viestiä, voit jättää sen turvallisesti huomiotta."
